# WikiRunner.pm
#
# Copyright (c) 2002 Cunningham & Cunningham, Inc.
# Released under the terms of the GNU General Public License version 2 or later.
#
# Perl translation by Dave W. Smith <dws@postcognitive.com>

package WikiRunner;

use base qw(FileRunner);
use strict;

sub process {
    my($self) = @_;
    eval {
	$self->{'tables'} = new Parse($self->{'input'}, qw(wiki table tr td));
	$self->{'fixture'}->doTables($self->{'tables'}->parts());
    };
    if ( $@ ) {
	$self->exception($@);
    }

    $self->{'output'}->print( $self->{'tables'}->asString());
}

1;
